      subroutine cost_3dvar(u, v, phi, n, m, nt, k, uobs, vobs, phiobs, costu, costv, costp, &
          UObsStddev, VObsStddev, PhiObsStddev)

      implicit none

! size parameters
      integer, intent(in) :: n, m, nt, k

      double precision, intent(out) :: costu, costv, costp

! state variables
      double precision, intent(inout), dimension(n, m, nt) :: u, v, phi

! observation variables
      double precision, intent(in), dimension(n, m, nt) :: uobs, vobs, phiobs
      double precision, intent(in) :: UObsStddev, VObsStddev, PhiObsStddev

! domain length and depth in m
      double precision :: length, depth, h0, h1, h2

! local variables
      integer :: i, j

      double precision :: uval, vval, phival
      double precision :: costu0, costv0, costp0

      costu0 = 1.0
      costv0 = 1.0
      costp0 = 1.0

      costu = 0.0
      costv = 0.0
      costp = 0.0

      do j = 2, m-1
          do i = 2, n-1

              call obs_operator(u(i,j,k),v(i,j,k),phi(i,j,k),uval,vval,phival)

              costu = costu &
                      + (uval-uobs(i,j,k)) &
                      * (uval-uobs(i,j,k))/(UObsStddev**2)

              costv = costv &
                      + (vval-vobs(i,j,k)) &
                      * (vval-vobs(i,j,k))/(VObsStddev**2)

              costp = costp &
                      + (phival-phiobs(i,j,k)) &
                      * (phival-phiobs(i,j,k))/(PhiObsStddev**2)

           enddo
      enddo

      costu = costu/costu0
      costv = costv/costv0
      costp = costp/costp0

      return
      end
